use strict;

package AlphaSerializer;

@AlphaSerializer::ISA='SOAP::Serializer';


# Mthode de srialization.
# Pour les instances des autres classes  srialiser, il suffit de recopier le contenu
# de cette mthode dans une mthode appele :
#              as_MachinChose
# Pour des classes dans des sous-packages (ex.: MonPackage::MaClasse), il faut remplacer
# les :: par des __, ce qui donnerait :
#              as_MonPackage__MaClasse
sub as_SoapOrganism {
    my $self=shift;
    my ($value, $name, $type, $attr) = @_;
    return [
	    $name || $self->SUPER::gen_name(),
	    {%$attr, 'xsi:type' => $self->maptypetouri($type)},
	    [map {$self->encode_object($value->{$_}, $_)} sort { $a cmp $b } keys %$value ],
	    $self->gen_id($value)
	    ];
}

sub as_SoapElement {
    my $self=shift;
    my ($value, $name, $type, $attr) = @_;
    
    return [
	    $name || $self->SUPER::gen_name(),
	    {%$attr, 'xsi:type' => $self->maptypetouri($type)},
	    [map {$self->encode_object($value->{$_}, $_)} sort { $a cmp $b } keys %$value ],
	    $self->gen_id($value)
	    ];
}

sub as_SoapGene {
    my $self=shift;
    my ($value, $name, $type, $attr) = @_;
    
    return [
	    $name || $self->SUPER::gen_name(),
	    {%$attr, 'xsi:type' => $self->maptypetouri($type)},
	    [map {$self->encode_object($value->{$_}, $_)} sort { $a cmp $b } keys %$value ],
	    $self->gen_id($value)
	    ];
}

# Pas sur quelle marche car concidere comme deux Complexestypes gene et geneWS.
sub as_SoapGeneWithState {
    my $self=shift;
    my ($value, $name, $type, $attr) = @_;
    
    return [
	    $name || $self->SUPER::gen_name(),
	    {%$attr, 'xsi:type' => $self->maptypetouri($type)},
	    [map {$self->encode_object($value->{$_}, $_)} sort { $a cmp $b } keys %$value ],
	    $self->gen_id($value)
	    ];
}

# Pas sur quelle marche car concidere comme deux Complexestypes elt et eltWS.
sub as_SoapElementWithState {
    my $self=shift;
    my ($value, $name, $type, $attr) = @_;

    return [
	    $name || $self->SUPER::gen_name(),
	    {%$attr, 'xsi:type' => $self->maptypetouri($type)},
	    [map {$self->encode_object($value->{$_}, $_)} sort { $a cmp $b } keys %$value ],
	    $self->gen_id($value)
	    ];
}


package SoapOrganism;

sub  new {
    my $class=shift;
    my $organism=shift;
    my $self={
	name=>SOAP::Data->type('string')->value($organism->{name}),
	organism_Id=>SOAP::Data->type('string')->value($organism->{organism_Id}),	
	shortName=>SOAP::Data->type('string')->value($organism->{shortName})
	};
    bless $self,$class;
    return $self ;
}

package SoapElement;

sub new {
    my $class=shift;
    my $element=shift;
    my $self={
	accession=>SOAP::Data->type('string')->value($element->{accession}),
	description=>SOAP::Data->type('string')->value($element->{description}),
	element_Id=>SOAP::Data->type('string')->value($element->{element_Id}),
	organism_Id=>SOAP::Data->type('string')->value($element->{organism_Id}),
	taille=>SOAP::Data->type('string')->value($element->{taille}),
	type=>SOAP::Data->type('string')->value($element->{type})
	};
    return bless $self,$class;
}

package SoapElementWithState;

sub new {
    my $class=shift;
    my $element=shift;
    my $self={
	accession=>SOAP::Data->type('string')->value($element->{accession}),
	description=>SOAP::Data->type('string')->value($element->{description}),
	element_Id=>SOAP::Data->type('string')->value($element->{element_Id}),
	organism_Id=>SOAP::Data->type('string')->value($element->{organism_Id}),
	taille=>SOAP::Data->type('string')->value($element->{taille}),
	type=>SOAP::Data->type('string')->value($element->{type}),
	geneRAtypical=>SOAP::Data->type('string')->value($element->{geneRAtypical}),
	geneRForward=>SOAP::Data->type('string')->value($element->{geneRForward}),
	geneRReverse=>SOAP::Data->type('string')->value($element->{geneRReverse})
	};
    return bless $self,$class;
}
package SoapGene;

sub new {
    my $class=shift;
    my $gene=shift;
    my $self={	
	element_Id=>SOAP::Data->type('string')->value($gene->{element_Id}),
	gene_Id=>SOAP::Data->type('string')->value($gene->{organism_Id}),
	name=>SOAP::Data->type('string')->value($gene->{name}),
	start=>SOAP::Data->type('string')->value($gene->{start}),
	stop=>SOAP::Data->type('string')->value($gene->{stop}),
	strand=>SOAP::Data->type('string')->value($gene->{strand})
    };
    return bless $self,$class;
}
package SoapGeneWithState;

sub new {
    my $class=shift; 
    my $gene=shift;
    my $self={	
	element_Id=>SOAP::Data->type('string')->value($gene->{element_Id}),
	gene_Id=>SOAP::Data->type('string')->value($gene->{organism_Id}),
	name=>SOAP::Data->type('string')->value($gene->{name}),
	start=>SOAP::Data->type('string')->value($gene->{start}),
	stop=>SOAP::Data->type('string')->value($gene->{stop}),
	strand=>SOAP::Data->type('string')->value($gene->{strand}),
	state=>SOAP::Data->type('string')->value($gene->{state})
    };
    return bless $self,$class;
}

1;


