
package Handler;
use strict;
use SOAP::Lite;

my $seqdbservice=undef;
my $orgservice=undef;
my $resultservice=undef;

# a modifier
sub _init {
#init du service Seqdb
    $seqdbservice=SOAP::Lite->service('http://138.102.22.145:8080/Seqdb/Seqdb_service?WSDL')->xmlschema(2001);
   #on pourrait installer un foreach handler pour parser le fichier Wsdl et creer les mattypes correspondant.
    $seqdbservice->maptype->{Organism}='http://Seqdb.org/types/Seqdb_service';
    $seqdbservice->maptype->{ArrayOfOrganism}='http://Seqdb.org/types/Seqdb_service';
    $seqdbservice->maptype->{ArrayOfstring}='http://Seqdb.org/types/Seqdb_service';
    #Pour chaque type,on pourrait creer sa structure soap correspondante.

#init du service Organism
    $orgservice=SOAP::Lite->service('http://138.102.22.145:8080/Seqdb/Organism_service?WSDL')->xmlschema(2001);
    $orgservice->serializer(new AlphaSerializer());
    $orgservice->maptype->{Organism}='http://Seqdb.org/types/Organism_service';
    $orgservice->maptype->{ArrayOfOrganism}='http://Seqdb.org/types/Organism_service';
    $orgservice->maptype->{Element}='http://Seqdb.org/types/Organism_service';
    $orgservice->maptype->{ArrayOfElement}='http://Seqdb.org/types/Organism_service';
    $orgservice->maptype->{Gene}='http://Seqdb.org/types/Organism_service';
    $orgservice->maptype->{ArrayOfGene}='http://Seqdb.org/types/Organism_service';

#init du service Result 
    $resultservice=SOAP::Lite->service('http://138.102.22.145:8080/Seqdb/Result_service?WSDL')->xmlschema(2001);
    $resultservice->serializer(new AlphaSerializer());
    $resultservice->maptype->{Element}='http://Seqdb.org/types/Result_service';
    $resultservice->maptype->{ArrayOfElement}='http://Seqdb.org/types/Result_service';
 }

sub getOrganisms{
    my $self=shift;
    _init unless $seqdbservice;
    my $organisms=$seqdbservice->getOrganisms();
    return $organisms;
} 

sub getElements{
    my $self=shift;
    my $organisms=shift;
    _init unless $orgservice;

    my @organismstab=();
   foreach my $org (@$organisms) {
       push @organismstab, new SoapOrganism($org);
    }
    my $SOAPorgtab=SOAP::Data->type('ArrayOfOrganism')->value(\@organismstab);
    my $elements=$orgservice->getElementsByOrganisms($SOAPorgtab);
    return $elements;
    }
sub getGeneAtypicals{
    my $self=shift;
    my $element=shift;
    _init unless $resultservice;
    my $SOAPelement=new SoapElement($element);
    my $genesWS=$resultservice->getGeneAtypicalsByElement($SOAPelement);
    return $genesWS;
}
1;
