package CompAnalResultSource::SeqDBResultSource::SeqDBCompAnalResult;
 
use strict;

use CompAnalResultSource;

@CompAnalResultSource::SeqDBResultSource::SeqDBCompAnalResult::ISA=qw(CompAnalResultSource);

sub  new {
    my $class=shift;
    my $item=shift;
    my $orgname=shift;
    my $element = shift;
    
    my $self= _new CompAnalResultSource;
    $self->{valign}='above';
    
    bless $self,$class;
    
    my $result =  $self-> _load_result($item,$orgname,$element);
   
    push @{$self->{companalresults}},$result;

    return $self;
}

sub _load_result {
    my ($self,$itemselected,$orgname,$elt ) = @_;
    my $companalResultsAttributes={
	'type' =>  'separate',
	'comment' => $itemselected." from ".$orgname." ".$elt->{type}." ".$elt->{accession}
	
	}; 
    
    my $result;
    if ($itemselected  eq "Atypical Genes"){
	$result=$self->_create_boxPlot($companalResultsAttributes,$elt);
    }
    return $result;
}

#boxplot result
sub _create_boxPlot{
    my ($self,$companalResultsAttributes,$elt ) = @_;

    my $boxeresult = new CompAnalResult::BoxPlotResult($companalResultsAttributes);
   
    my $min=1e10;
    my $max=-1;
    my $genes= CompAnalResultSource::SeqDBResultSource::SeqDBResultHandler->getAtypicalGenes($elt);
    foreach my $gene (@$genes) {
	my $currentbox={};
	#'vpos'=>,
	#'top'=>,
	#'labelcolor'=>   
	$max=$gene->{stop}
	if ($gene->{stop} > $max);
	$min=$gene->{start}
	if ($gene->{start} < $min);
	$currentbox->{begin}=$gene->{start};
	$currentbox->{end}=$gene->{stop};
	$currentbox->{strand}=$gene->{strand};
	$currentbox->{color}='green';
	$currentbox->{thickness}=0.3;
	$currentbox->{filled}=0;
	$currentbox->{label}=$gene->{name};
	$currentbox->{halign}='middle';
	if ($self->valign eq 'above' ){
	    $currentbox->{valign}='below';
	    $self->valign('below');
	}
	else{
	    $currentbox->{valign}='above';
	    $self->valign('above');
	}
	$currentbox->{frame} = 'none';
	push @{$boxeresult->{boxes}},$currentbox;
	push @{$boxeresult->{highlights}},{begin =>$currentbox->{begin},
			  end => $currentbox->{end},
			  label => $currentbox->{label}};
    }
    $boxeresult->{start}=$min;
    $boxeresult->{end}=$max;
    return $boxeresult;
}
sub valign{
   my $self= shift;
   
    if(my $valign=shift){
	$self->{valign}=$valign;
    }
    return $self->{valign};
}
1;
