package PreferencesHandler;

use strict;

use XML::DOM;

BEGIN {
    XML::DOM::ignoreReadOnly(1);
    my $doc=new XML::DOM::Document;
    my $decl=$doc->createXMLDecl("1.0","ISO-8859-1","yes");
    $doc->setXMLDecl($decl);
    my $doctype=$doc->createDocumentType("mugen");
    $doctype->addElementDecl("mugen","(featuredatasources|resultdatasources|mapdisplay|features|thresholds|highlights|links|browser)*");
    $doc->setDoctype($doctype);
    my $mugen=$doc->createElement("mugen");
      
    $doc->appendChild($mugen);
    $PreferencesHandler::Preferences=$doc;
}

sub set_preferences_file {
    my $prefsfile=shift;
    $PreferencesHandler::PrefsFile=$prefsfile;
}

sub load_preferences {

    if (-r "$PreferencesHandler::PrefsFile") {
	my $parser=new XML::DOM::Parser;
	$PreferencesHandler::Preferences=$parser->parsefile($PreferencesHandler::PrefsFile);
    } else {
	warn ("Unable to load preferences from file $PreferencesHandler::PrefsFile.\n");
    }
}


sub save_preferences {
    
    $PreferencesHandler::Preferences->printToFile($PreferencesHandler::PrefsFile);
}

1;

